subroutine Drawworks_Outputs
    
    Use CSounds
    Use CHookVariables
    Use CWarningsVariables
    Use Drawworks_VARIABLES
    Use CDrillingConsoleVariables
    
    IMPLICIT NONE
    
    
    
    DrillingConsole%DWBLWR = Drawworks%BLWR
    
    Call SetSoundBlowerDW( Drawworks%SoundBlower )               !.true. or .false.
    Call SetSoundDwRev( Drawworks%SoundRev )                     ![rpm] ??? or rad/s, Integer
    Call SetSoundDwFw( Drawworks%SoundFw )                       ![rpm] , Integer     
    Call SetSoundCrownCollision( Drawworks%SoundCrownCollision ) !.true. or .false.
    Call SetSoundFloorCollision( Drawworks%SoundFloorCollision ) !.true. or .false.
   
    if (Drawworks%CrownCollision==1) then
        Call Activate_CrownCollision()
    end if
    if (Drawworks%FloorCollision==1) then
        Call Activate_FloorCollision()
    end if
    
    Call Set_HookHeight( real(Drawworks%Hook_Height_final) )     ![ft]
    Drawworks%TDHookHeight = Drawworks%Hook_Height_final         ![ft]
    !!Drawworks%HookHeight_graph_output
    
    !DrillingConsole%ParkingBrakeLed = 0     ! in Drawworks_Inputs
    
    
    
    
end subroutine Drawworks_Outputs