SUBROUTINE Utube2_and_TripIn    !  is called in subroutine CirculationCodeSelect        annulus to string
    
        Use UTUBEVARS
        Use GeoElements_FluidModule
        USE CMudPropertiesVariables
        USE MudSystemVARIABLES
        USE Pumps_VARIABLES
        use CDrillWatchVariables
        !use CTanksVariables, TripTankVolume2 => DrillingWatch%TripTankVolume, TripTankDensity2 => TripTankDensity
        Use CShoeVariables
 
   implicit none
   
    write(*,*) 'Utube2 code'
    
!===========================================================WELL============================================================
!===========================================================WELL============================================================ 
    
        MudSystem%UtubeMode2Activated= .true.
        write(*,*) 'QUtubeOutput=' , QUtubeOutput
        !QUTubeInput=5000.
        MudSystem%StringFlowRate= QUtubeOutput        ! (gpm)
        MudSystem%AnnulusFlowRate= QUtubeOutput
        MudSystem%StringFlowRateFinal= MudSystem%StringFlowRate
        MudSystem%AnnulusFlowRateFinal= MudSystem%AnnulusFlowRate
!=========================================== 
       
        if (MudSystem%FirstSetUtube2==0) then
        !    call St_MudDischarged_Volume%AddToFirst (REAL(sum(F_Interval(1:F_StringIntervalCounts)%Volume)))  !startup initial
        !    call St_Mud_Backhead_X%AddToFirst (Xstart_PipeSection(1))
        !    call St_Mud_Backhead_section%AddToFirst (1)
        !    call St_Mud_Forehead_X%AddToFirst (Xend_PipeSection(F_StringIntervalCounts))
        !    call St_Mud_Forehead_section%AddToFirst (F_StringIntervalCounts)
        !    call MudSystem%St_Density%AddToFirst (REAL(ActiveDensity))       ! initial(ppg)
        !    call St_RemainedVolume_in_LastSection%AddToFirst (0.0d0)
        !    call St_EmptyVolume_inBackheadLocation%AddToFirst (0.0d0)
        !        
        !    call Ann_MudDischarged_Volume%AddToFirst (REAL(sum(F_Interval((F_StringIntervalCounts+F_BottomHoleIntervalCounts+1):F_IntervalsTotalCounts)%Volume)))  !startup initial
        !    call Ann_Mud_Backhead_X%AddToFirst (Xstart_PipeSection(F_StringIntervalCounts+1))
        !    call Ann_Mud_Backhead_section%AddToFirst (F_StringIntervalCounts+1)
        !    call Ann_Mud_Forehead_X%AddToFirst (Xend_PipeSection(NoPipeSections))
        !    call Ann_Mud_Forehead_section%AddToFirst (NoPipeSections)
        !    call Ann_Density%AddToFirst (REAL(ActiveDensity))       ! initial(ppg)
        !    call Ann_RemainedVolume_in_LastSection%AddToFirst (0.0d0)
        !    call Ann_EmptyVolume_inBackheadLocation%AddToFirst (0.0d0)
             !Hz_Density%Array(:)= 0.0
             !Hz_MudOrKick%Array(:)= 104
             
             MudSystem%Hz_Density_Utube= 0.0
             MudSystem%Hz_MudOrKick_Utube= 104
             
            MudSystem%FirstSetUtube2= 1
        endif

        
        
        
!========================Horizontal PIPE ENTRANCE================= 
        
         !if (SuctionDensity_Old >= (ActiveDensity+0.05) .or. SuctionDensity_Old <= (ActiveDensity-0.05)) then     ! new mud is pumped
         !   !ImudCount= ImudCount+1
         !   !SuctionMud= ImudCount
         !   call Hz_Density%AddToFirst (REAL(ActiveDensity))     !ActiveDensity : badan in moteghayer bayad avaz beshe
         !   call Hz_MudDischarged_Volume%AddToFirst (0.0d0)
         !   call Hz_Mud_Forehead_X%AddToFirst (Xstart_PipeSection(1))
         !   call Hz_Mud_Forehead_section%AddToFirst (1)
         !   call Hz_Mud_Backhead_X%AddToFirst (Xstart_PipeSection(1))
         !   call Hz_Mud_Backhead_section%AddToFirst (1)
         !   call Hz_RemainedVolume_in_LastSection%AddToFirst (0.0d0)
         !   call Hz_EmptyVolume_inBackheadLocation%AddToFirst (0.0d0)
         !   call Hz_MudOrKick%AddToFirst (0)  
        
         !   deltaV= 0.
         !    
         !    SuctionDensity_Old= ActiveDensity
         !endif

!========================Horizontal PIPE STRING================= 
        
        !commented

!                Hz_MudDischarged_Volume%Array(1)= Hz_MudDischarged_Volume%Array(1)+ ((MudSystem%StringFlowRate/60.)*DeltaT_Mudline)    !(gal)
!         
!imud=0                               
!    do while (imud < Hz_Mud_Forehead_X%Length())
!        imud = imud + 1               
!        
!            if (imud> 1) then
!                Hz_Mud_Backhead_X%Array(imud)= Hz_Mud_Forehead_X%Array(imud-1)
!                Hz_Mud_Backhead_section%Array(imud)= Hz_Mud_Forehead_section%Array(imud-1)
!            endif
!            
!                
!            DirectionCoef= (Xend_PipeSection(Hz_Mud_Backhead_section%Array(imud))-Xstart_PipeSection(Hz_Mud_Backhead_section%Array(imud))) &
!                / ABS(Xend_PipeSection(Hz_Mud_Backhead_section%Array(imud))-Xstart_PipeSection(Hz_Mud_Backhead_section%Array(imud)))
!            ! +1 for string  ,   -1 for annulus
!                
!                                                                                                                    
!            Hz_EmptyVolume_inBackheadLocation%Array(imud)= DirectionCoef* (Xend_PipeSection(Hz_Mud_Backhead_section%Array(imud))- Hz_Mud_Backhead_X%Array(imud))* &
!                Area_PipeSectionFt(Hz_Mud_Backhead_section%Array(imud)) !(ft^3)          
!            Hz_EmptyVolume_inBackheadLocation%Array(imud)= Hz_EmptyVolume_inBackheadLocation%Array(imud)* 7.48051948        ! ft^3  to gal
!            
!
!            if ( Hz_MudDischarged_Volume%Array(imud) <= Hz_EmptyVolume_inBackheadLocation%Array(imud)) then
!                Hz_Mud_Forehead_section%Array(imud)= Hz_Mud_Backhead_section%Array(imud)
!                Hz_Mud_Forehead_X%Array(imud)= Hz_Mud_Backhead_X%Array(imud)+ DirectionCoef*(Hz_MudDischarged_Volume%Array(imud)/7.48051948)/Area_PipeSectionFt(Hz_Mud_Backhead_section%Array(imud))
!                                                                            !   7.48051948 is for gal to ft^3
!            else
!                    
!                isection= Hz_Mud_Backhead_section%Array(imud)+1
!                Hz_RemainedVolume_in_LastSection%Array(imud)= Hz_MudDischarged_Volume%Array(imud)- Hz_EmptyVolume_inBackheadLocation%Array(imud)
!                    
!                do 
!                        if (isection > 1) then        ! (horizontal pipe exit)
!                            Hz_MudDischarged_Volume%Array(imud)= Hz_MudDischarged_Volume%Array(imud)- Hz_RemainedVolume_in_LastSection%Array(imud)
!                            Hz_Mud_Forehead_X%Array(imud)= Xend_PipeSection(1)
!                            Hz_Mud_Forehead_section%Array(imud)= 1
!                            if (Hz_MudDischarged_Volume%Array(imud)<= 0.0d0)  then       ! imud is completely exited form the string
!                                call Hz_MudDischarged_Volume%Remove (imud)
!                                call Hz_Mud_Backhead_X%Remove (imud)
!                                call Hz_Mud_Backhead_section%Remove (imud)
!                                call Hz_Mud_Forehead_X%Remove (imud)
!                                call Hz_Mud_Forehead_section%Remove (imud)
!                                call Hz_Density%Remove (imud)
!                                call Hz_RemainedVolume_in_LastSection%Remove (imud)
!                                call Hz_EmptyVolume_inBackheadLocation%Remove (imud)
!                                call Hz_MudOrKick%Remove (imud)
!                            endif
!                            exit
!                        endif
!                                 
!                    xx= Hz_RemainedVolume_in_LastSection%Array(imud)/ PipeSection_VolumeCapacity(isection)   !(gal)
!                        
!                    if (xx<= 1.0) then
!                        Hz_Mud_Forehead_section%Array(imud)= isection
!                        Hz_Mud_Forehead_X%Array(imud)= (xx * (Xend_PipeSection(isection)- Xstart_PipeSection(isection)))+ Xstart_PipeSection(isection)
!                        exit
!                    else
!                        Hz_RemainedVolume_in_LastSection%Array(imud)= Hz_RemainedVolume_in_LastSection%Array(imud)- PipeSection_VolumeCapacity(isection)
!                        isection= isection+ 1
!                        
!                                
!                    endif
!
!                enddo
!            
!            endif   
!        
!    enddo
    
        !commented
    
!========================Horizontal PIPE END=================         

!========================ANNULUS ENTRANCE==================== 
        
         if (ABS(MudSystem%AnnulusSuctionDensity_Old - MudSystem%Hz_Density_Utube) >= MudSystem%DensityMixTol ) then     ! new mud is pumped
            call MudSystem%Ann_Density%Add (MudSystem%Hz_Density_Utube)   
            call MudSystem%Ann_MudDischarged_Volume%Add (0.0d0)
            call MudSystem%Ann_Mud_Forehead_X%Add (MudSystem%Xend_PipeSection(MudSystem%NoPipeSections))
            call MudSystem%Ann_Mud_Forehead_section%Add (MudSystem%NoPipeSections)
            call MudSystem%Ann_Mud_Backhead_X%Add (MudSystem%Xstart_PipeSection(MudSystem%NoPipeSections))
            call MudSystem%Ann_Mud_Backhead_section%Add (MudSystem%NoPipeSections)
            call MudSystem%Ann_RemainedVolume_in_LastSection%Add (0.0d0)
            call MudSystem%Ann_EmptyVolume_inBackheadLocation%Add (0.0d0)
            call MudSystem%Ann_MudOrKick%Add (MudSystem%Hz_MudOrKick_Utube)      ! Hz_MudOrKick%Last() = 104
            call MudSystem%Ann_CuttingMud%Add (0)
             
             MudSystem%AnnulusSuctionDensity_Old= MudSystem%Hz_Density_Utube
         endif    
         
!========================ANNULUS==================== 

                MudSystem%Ann_MudDischarged_Volume%Array(MudSystem%Ann_MudDischarged_Volume%Length())= MudSystem%Ann_MudDischarged_Volume%Last()+ ((MudSystem%AnnulusFlowRate/60.)*MudSystem%DeltaT_Mudline)    !(gal)
         
imud= MudSystem%Ann_Mud_Forehead_X%Length() + 1

    do while (imud > 1)
        imud = imud - 1 
        
            if (imud< MudSystem%Ann_Mud_Forehead_X%Length()) then
                MudSystem%Ann_Mud_Forehead_X%Array(imud)= MudSystem%Ann_Mud_Backhead_X%Array(imud+1)
                MudSystem%Ann_Mud_Forehead_section%Array(imud)= MudSystem%Ann_Mud_Backhead_section%Array(imud+1)
            endif

!       <<< Fracture Shoe Lost            
            IF ( MudSystem%ShoeLost .and. MudSystem%LostInTripOutIsDone== .false.  .and. Shoe%ShoeDepth < MudSystem%Ann_Mud_Backhead_X%Array(imud) .and. Shoe%ShoeDepth >= MudSystem%Ann_Mud_Forehead_X%Array(imud) ) then
                !write(*,*) 'ShoeLost   imud,AnnVolume(imud), VolumeLost:' , imud,Ann_MudDischarged_Volume%Array(imud), (( Qlost/60.0d0)*DeltaT_Mudline)
                MudSystem%Ann_MudDischarged_Volume%Array(imud)= MudSystem%Ann_MudDischarged_Volume%Array(imud)-((MudSystem%Qlost/60.0d0)*MudSystem%DeltaT_Mudline)    !(gal)
                if (MudSystem%Ann_MudDischarged_Volume%Array(imud) < 0.0) then
                    !write(*,*) 'mud is removed by shoe lost, imud=' , imud
                    call RemoveAnnulusMudArrays(imud)
                    imud= imud-1
                    cycle
                endif
            ENDIF
!           Fracture Shoe Lost >>>             
 
            
            MudSystem%DirectionCoef= (MudSystem%Xend_PipeSection(MudSystem%Ann_Mud_Forehead_section%Array(imud))-MudSystem%Xstart_PipeSection(MudSystem%Ann_Mud_Forehead_section%Array(imud))) &
                / ABS(MudSystem%Xend_PipeSection(MudSystem%Ann_Mud_Forehead_section%Array(imud))-MudSystem%Xstart_PipeSection(MudSystem%Ann_Mud_Forehead_section%Array(imud)))
            ! +1 for string  ,   -1 for annulus
                
                                                                                                                    
            MudSystem%Ann_EmptyVolume_inBackheadLocation%Array(imud)= MudSystem%DirectionCoef* (MudSystem%Ann_Mud_Forehead_X%Array(imud)- MudSystem%Xstart_PipeSection(MudSystem%Ann_Mud_Forehead_section%Array(imud)))* &
                MudSystem%Area_PipeSectionFt(MudSystem%Ann_Mud_Forehead_section%Array(imud)) !(ft^3)          
            MudSystem%Ann_EmptyVolume_inBackheadLocation%Array(imud)= MudSystem%Ann_EmptyVolume_inBackheadLocation%Array(imud)* 7.48051948d0        ! ft^3  to gal
            

            if ( MudSystem%Ann_MudDischarged_Volume%Array(imud) <= MudSystem%Ann_EmptyVolume_inBackheadLocation%Array(imud)) then
                MudSystem%Ann_Mud_Backhead_section%Array(imud)= MudSystem%Ann_Mud_Forehead_section%Array(imud)
                MudSystem%Ann_Mud_Backhead_X%Array(imud)= MudSystem%Ann_Mud_Forehead_X%Array(imud)- MudSystem%DirectionCoef*(MudSystem%Ann_MudDischarged_Volume%Array(imud)/7.48051948d0)/MudSystem%Area_PipeSectionFt(MudSystem%Ann_Mud_Forehead_section%Array(imud))
                                                                            !   7.48051948 is for gal to ft^3
            else
                    
                MudSystem%isection= MudSystem%Ann_Mud_Forehead_section%Array(imud)-1
                MudSystem%Ann_RemainedVolume_in_LastSection%Array(imud)= MudSystem%Ann_MudDischarged_Volume%Array(imud)- MudSystem%Ann_EmptyVolume_inBackheadLocation%Array(imud)
                    
                do 
                        if (MudSystem%isection < F_Counts%StringIntervalCounts+1) then        ! last pipe section(well exit) F_Counts%StringIntervalCounts+1 is the first section in Annulus
                            MudSystem%Ann_MudDischarged_Volume%Array(imud)= MudSystem%Ann_MudDischarged_Volume%Array(imud)- MudSystem%Ann_RemainedVolume_in_LastSection%Array(imud)
                            MudSystem%Ann_Mud_Backhead_X%Array(imud)= MudSystem%Xstart_PipeSection(F_Counts%StringIntervalCounts+1)
                            MudSystem%Ann_Mud_Backhead_section%Array(imud)= F_Counts%StringIntervalCounts+1
                            
                            if (MudSystem%Ann_MudDischarged_Volume%Array(imud)<= 0.0d0)  then       ! imud is completely exited form the well
                                call RemoveAnnulusMudArrays(imud)
                            endif
                            
                            exit
                        endif
                                 
                    MudSystem%xx= MudSystem%Ann_RemainedVolume_in_LastSection%Array(imud)/ MudSystem%PipeSection_VolumeCapacity(MudSystem%isection)   !(gal)
                        
                    if (MudSystem%xx<= 1.0) then
                        MudSystem%Ann_Mud_Backhead_section%Array(imud)= MudSystem%isection
                        MudSystem%Ann_Mud_Backhead_X%Array(imud)= (MudSystem%xx * (MudSystem%Xstart_PipeSection(MudSystem%isection)- MudSystem%Xend_PipeSection(MudSystem%isection)))+ MudSystem%Xend_PipeSection(MudSystem%isection)
                        exit
                    else
                        MudSystem%Ann_RemainedVolume_in_LastSection%Array(imud)= MudSystem%Ann_RemainedVolume_in_LastSection%Array(imud)- MudSystem%PipeSection_VolumeCapacity(MudSystem%isection)
                        MudSystem%isection= MudSystem%isection- 1
                        
                                
                    endif

                enddo
            
            endif   
        
    enddo
!========================ANNULUS END=================    
    
!========================== tripping in for OP remove ===============================   
                
    !if (DeltaVolumeOp>0. .and. DeltaVolumeOp< Op_MudDischarged_Volume%Last()) then
    !    Op_MudDischarged_Volume%Array(Op_MudDischarged_Volume%Length())= Op_MudDischarged_Volume%Array(Op_MudDischarged_Volume%Length()) - DeltaVolumeOp
    !else
    !    Op_MudDischarged_Volume%Array(Op_MudDischarged_Volume%Length()-1)=  Op_MudDischarged_Volume%Array(Op_MudDischarged_Volume%Length()-1) - (DeltaVolumeOp-Op_MudDischarged_Volume%Last())
    !                
    !    call Op_MudDischarged_Volume%Remove (Op_MudDischarged_Volume%Length())
    !    call Op_Mud_Backhead_X%Remove (Op_MudDischarged_Volume%Length())
    !    call Op_Mud_Backhead_section%Remove (Op_MudDischarged_Volume%Length())
    !    call Op_Mud_Forehead_X%Remove (Op_MudDischarged_Volume%Length())
    !    call Op_Mud_Forehead_section%Remove (Op_MudDischarged_Volume%Length())
    !    call Op_Density%Remove (Op_MudDischarged_Volume%Length())
    !    call Op_RemainedVolume_in_LastSection%Remove (Op_MudDischarged_Volume%Length())
    !    call Op_EmptyVolume_inBackheadLocation%Remove (Op_MudDischarged_Volume%Length())
    !    call Op_MudOrKick%Remove (Op_MudDischarged_Volume%Length())
    !endif
    !     

!============================= Bottom Hole ============================== 
        
                !Op_MudDischarged_Volume%Array(1)= Op_MudDischarged_Volume%Array(1)+ ((GasKickPumpFlowRate/60.)*DeltaT_Mudline)    !(gal)    due to KickFlux    
imud=0                     
    do while (imud < MudSystem%Op_Mud_Forehead_X%Length())
        imud = imud + 1
        
            if (imud> 1) then
                MudSystem%Op_Mud_Backhead_X%Array(imud)= MudSystem%Op_Mud_Forehead_X%Array(imud-1)
                MudSystem%Op_Mud_Backhead_section%Array(imud)= MudSystem%Op_Mud_Forehead_section%Array(imud-1)
            endif
            
                
            MudSystem%DirectionCoef= (MudSystem%Xend_OpSection(MudSystem%Op_Mud_Backhead_section%Array(imud))-MudSystem%Xstart_OpSection(MudSystem%Op_Mud_Backhead_section%Array(imud))) &
                / ABS(MudSystem%Xend_OpSection(MudSystem%Op_Mud_Backhead_section%Array(imud))-MudSystem%Xstart_OpSection(MudSystem%Op_Mud_Backhead_section%Array(imud)))
            ! +1 for string  ,   -1 for annulus
                
                           
                                                                                                                    
            MudSystem%Op_EmptyVolume_inBackheadLocation%Array(imud)= MudSystem%DirectionCoef* (MudSystem%Xend_OpSection(MudSystem%Op_Mud_Backhead_section%Array(imud))- MudSystem%Op_Mud_Backhead_X%Array(imud))* &
                MudSystem%Area_OpSectionFt(MudSystem%Op_Mud_Backhead_section%Array(imud)) !(ft^3)          
            MudSystem%Op_EmptyVolume_inBackheadLocation%Array(imud)= MudSystem%Op_EmptyVolume_inBackheadLocation%Array(imud)* 7.48051948d0        ! ft^3  to gal
            
         
            if ( MudSystem%Op_MudDischarged_Volume%Array(imud) <= MudSystem%Op_EmptyVolume_inBackheadLocation%Array(imud)) then
                MudSystem%Op_Mud_Forehead_section%Array(imud)= MudSystem%Op_Mud_Backhead_section%Array(imud)
                MudSystem%Op_Mud_Forehead_X%Array(imud)= MudSystem%Op_Mud_Backhead_X%Array(imud)+ MudSystem%DirectionCoef*(MudSystem%Op_MudDischarged_Volume%Array(imud)/7.48051948d0)/MudSystem%Area_OpSectionFt(MudSystem%Op_Mud_Backhead_section%Array(imud))
                                                                            !   7.48051948 is for gal to ft^3
                
            else
                    
                MudSystem%isection= MudSystem%Op_Mud_Backhead_section%Array(imud)+1
                MudSystem%Op_RemainedVolume_in_LastSection%Array(imud)= MudSystem%Op_MudDischarged_Volume%Array(imud)- MudSystem%Op_EmptyVolume_inBackheadLocation%Array(imud)
                    
                do 
                        if (MudSystem%isection > F_Counts%BottomHoleIntervalCounts) then        ! last pipe section(well exit)
                            if( imud==1) MudSystem%KickDeltaVinAnnulus= MudSystem%Op_RemainedVolume_in_LastSection%Array(imud)      ! Kick enters Annulus space
                            MudSystem%Op_MudDischarged_Volume%Array(imud)= MudSystem%Op_MudDischarged_Volume%Array(imud)- MudSystem%Op_RemainedVolume_in_LastSection%Array(imud)
                            MudSystem%Op_Mud_Forehead_X%Array(imud)= MudSystem%Xend_OpSection(F_Counts%BottomHoleIntervalCounts)
                            MudSystem%Op_Mud_Forehead_section%Array(imud)= F_Counts%BottomHoleIntervalCounts
                                
                            if (MudSystem%Op_MudDischarged_Volume%Array(imud)<= 0.0d0)  then        ! imud is completely exited form the well
                                call RemoveOpMudArrays(imud)
                            endif
                            
                            exit
                        endif
                                 
                    MudSystem%xx= MudSystem%Op_RemainedVolume_in_LastSection%Array(imud)/ MudSystem%OpSection_VolumeCapacity(MudSystem%isection)   !(gal)
                        
                    if (MudSystem%xx<= 1.0) then
                        MudSystem%Op_Mud_Forehead_section%Array(imud)= MudSystem%isection
                        MudSystem%Op_Mud_Forehead_X%Array(imud)= (MudSystem%xx * (MudSystem%Xend_OpSection(MudSystem%isection)- MudSystem%Xstart_OpSection(MudSystem%isection)))+ MudSystem%Xstart_OpSection(MudSystem%isection)
                        exit
                    else
                        MudSystem%Op_RemainedVolume_in_LastSection%Array(imud)= MudSystem%Op_RemainedVolume_in_LastSection%Array(imud)- MudSystem%OpSection_VolumeCapacity(MudSystem%isection)
                        MudSystem%isection= MudSystem%isection+ 1
                        
                    endif

                enddo
            
            endif   
        
        if (MudSystem%Op_Mud_Forehead_X%Array(imud)== MudSystem%Xend_OpSection(F_Counts%BottomHoleIntervalCounts)) then
            MudSystem%totalLength = MudSystem%Op_MudDischarged_Volume%Length()
            do while(imud < MudSystem%totalLength)
                
                !imud = imud + 1
                call RemoveOpMudArrays(MudSystem%totalLength)
                MudSystem%totalLength = MudSystem%totalLength - 1

                
            enddo
            
            exit ! 
            
        endif           

       !WRITE(*,*) imud,'Op_MudDischarged_Volume%Array(imud)' , Op_MudDischarged_Volume%Array(imud), Op_Density%Array(imud)

                   
            
            
            
            
    enddo


    !write(*,*) 'Op_Mud_Forehead_X%Length()' , Op_Mud_Forehead_X%Length()
    !
    !   WRITE(*,*) 'Xend_PipeSection(F_StringIntervalCounts)' , Xend_PipeSection(F_StringIntervalCounts)
    !   WRITE(*,*) 'Op_Mud_Backhead_X%Array(1)' , Op_Mud_Backhead_X%Array(1) 
    !   WRITE(*,*) 'Op_Mud_Forehead_X%Array(1)' , Op_Mud_Forehead_X%Array(1)
    !   WRITE(*,*) 'Op_Mud_Backhead_X%Array(2)' , Op_Mud_Backhead_X%Array(2) 
    !   WRITE(*,*) 'Op_Mud_Forehead_X%Array(2)' , Op_Mud_Forehead_X%Array(2) 
!========================Bottom Hole END=================          
    
    
    
    
  ! NO KICK  
    
    
     
!========================STRING ENTRANCE================= 
        
    if ((ABS(MudSystem%St_Density%Last() - MudSystem%Ann_Density%First()) >= MudSystem%DensityMixTol)  .OR. (MudSystem%DeltaVolumeOp == 0.0 .and. MudSystem%St_Density%Last() /= MudSystem%Ann_Density%Array(1) .and. MudSystem%StringFlowRate/=0.0d0)) then     ! new mud is pumped

    !if ((ABS(StringDensity_Old - Ann_Density%First()) >= DensityMixTol)  .OR. (DeltaVolumeOp == 0.0 .and. MudSystem%St_Density%Last() /= Ann_Density%Array(1) .and. MudSystem%StringFlowRate/=0.0d0)) then     ! new mud is pumped
            call MudSystem%St_Density%Add (MudSystem%Ann_Density%First())
            call MudSystem%St_MudDischarged_Volume%Add (0.0d0)
            call MudSystem%St_Mud_Forehead_X%Add (MudSystem%Xend_PipeSection(F_Counts%StringIntervalCounts))
            call MudSystem%St_Mud_Forehead_section%Add (F_Counts%StringIntervalCounts)
            call MudSystem%St_Mud_Backhead_X%Add (MudSystem%Xstart_PipeSection(F_Counts%StringIntervalCounts))
            call MudSystem%St_Mud_Backhead_section%Add (F_Counts%StringIntervalCounts)
            call MudSystem%St_RemainedVolume_in_LastSection%Add (0.0d0)
            call MudSystem%St_EmptyVolume_inBackheadLocation%Add (0.0d0)
            call MudSystem%St_MudOrKick%Add (0)
             
             !StringDensity_Old= Ann_Density%First()
             
             MudSystem%MudIsChanged= .true.
         endif

                         MudSystem%St_MudDischarged_Volume%Array(MudSystem%St_MudDischarged_Volume%Length())= MudSystem%St_MudDischarged_Volume%Last()+ ((MudSystem%StringFlowRate/60.0d0)*MudSystem%DeltaT_Mudline)    !(gal)

!========================Tripping In==================== 
         
!write(*,*) 'DeltaVolumeOp=' , DeltaVolumeOp
write(*,*) 'DeltaVolumeOp=' , MudSystem%DeltaVolumeOp 
            if (MudSystem%DeltaVolumeOp > 0.0 .and. MudSystem%MudIsChanged== .false.) then !.and. DrillingMode== .false.) then      ! trip in mode(loole paeen)  
                
            !write(*,*) 'Tripping In'
                            
                MudSystem%NewDensity= (MudSystem%Ann_Density%First()*((MudSystem%StringFlowRate/60.0d0)*MudSystem%DeltaT_Mudline)+MudSystem%Op_Density%Last()*MudSystem%DeltaVolumeOp)/(((MudSystem%StringFlowRate/60.0d0)*MudSystem%DeltaT_Mudline)+MudSystem%DeltaVolumeOp)
                MudSystem%NewVolume= ((MudSystem%StringFlowRate/60.0d0)*MudSystem%DeltaT_Mudline)+MudSystem%DeltaVolumeOp                

        !write(*,*) 'St_MudDischarged_Volume%Last()=', St_MudDischarged_Volume%Last(), 'NewVolume=', NewVolume

            if (abs(MudSystem%St_Density%Last()-MudSystem%NewDensity)< MudSystem%DensityMixTol) then ! .OR. (St_MudDischarged_Volume%Last()< 42.) ) then   !+ NewVolume)< 42.) then      ! 1-Pockets are Merged
                 MudSystem%St_Density%Array(MudSystem%St_Density%Length())= (MudSystem%St_Density%Last()*MudSystem%St_MudDischarged_Volume%Last()+MudSystem%NewDensity*MudSystem%NewVolume)/(MudSystem%St_MudDischarged_Volume%Last()+MudSystem%NewVolume)
                 MudSystem%St_MudDischarged_Volume%Array(MudSystem%St_Density%Length())= MudSystem%St_MudDischarged_Volume%Last()+MudSystem%DeltaVolumeOp
                 MudSystem%St_Mud_Forehead_X%Array(MudSystem%St_Density%Length())= (MudSystem%Xend_PipeSection(F_Counts%StringIntervalCounts))
                 MudSystem%St_Mud_Forehead_section%Array(MudSystem%St_Density%Length())= (F_Counts%StringIntervalCounts)
                 MudSystem%St_Mud_Backhead_X%Array(MudSystem%St_Density%Length())= (MudSystem%Xstart_PipeSection(F_Counts%StringIntervalCounts))
                 MudSystem%St_Mud_Backhead_section%Array(MudSystem%St_Density%Length())= (F_Counts%StringIntervalCounts)
                 MudSystem%St_RemainedVolume_in_LastSection%Array(MudSystem%St_Density%Length())= (0.0d0)
                 MudSystem%St_EmptyVolume_inBackheadLocation%Array(MudSystem%St_Density%Length())= (0.0d0)                  
            else        ! 2-Merging conditions are not meeted, so new pocket
                call MudSystem%St_Density%Add (MudSystem%NewDensity)
                call MudSystem%St_MudDischarged_Volume%Add (MudSystem%NewVolume)
                call MudSystem%St_Mud_Forehead_X%Add (MudSystem%Xend_PipeSection(F_Counts%StringIntervalCounts))
                call MudSystem%St_Mud_Forehead_section%Add (F_Counts%StringIntervalCounts)
                call MudSystem%St_Mud_Backhead_X%Add (MudSystem%Xstart_PipeSection(F_Counts%StringIntervalCounts))
                call MudSystem%St_Mud_Backhead_section%Add (F_Counts%StringIntervalCounts)
                call MudSystem%St_RemainedVolume_in_LastSection%Add (0.0d0)
                call MudSystem%St_EmptyVolume_inBackheadLocation%Add (0.0d0)
                call MudSystem%St_MudOrKick%Add (0)
            endif
            

            elseif (MudSystem%DeltaVolumeOp > 0.0 .and. MudSystem%MudIsChanged== .true.) then
                MudSystem%St_Density%Array(MudSystem%St_Density%Length())= MudSystem%NewDensity
                 MudSystem%St_MudDischarged_Volume%Array(MudSystem%St_Density%Length())= MudSystem%NewVolume
                 MudSystem%St_Mud_Forehead_X%Array(MudSystem%St_Density%Length())= (MudSystem%Xend_PipeSection(F_Counts%StringIntervalCounts))
                 MudSystem%St_Mud_Forehead_section%Array(MudSystem%St_Density%Length())= (F_Counts%StringIntervalCounts)
                 MudSystem%St_Mud_Backhead_X%Array(MudSystem%St_Density%Length())= (MudSystem%Xstart_PipeSection(F_Counts%StringIntervalCounts))
                 MudSystem%St_Mud_Backhead_section%Array(MudSystem%St_Density%Length())= (F_Counts%StringIntervalCounts)
                 MudSystem%St_RemainedVolume_in_LastSection%Array(MudSystem%St_Density%Length())= (0.0d0)
                 MudSystem%St_EmptyVolume_inBackheadLocation%Array(MudSystem%St_Density%Length())= (0.0d0)
    endif  
    
    
!========================Tripping In - End====================    
    
    
!======================== STRING ==================== 
    
            MudSystem%MudIsChanged= .false. 
            
 imud= MudSystem%St_Mud_Forehead_X%Length() + 1

    do while (imud > 1)
        imud = imud - 1                  
        
            if (imud< MudSystem%St_Mud_Forehead_X%Length()) then
                MudSystem%St_Mud_Forehead_X%Array(imud)= MudSystem%St_Mud_Backhead_X%Array(imud+1)
                MudSystem%St_Mud_Forehead_section%Array(imud)= MudSystem%St_Mud_Backhead_section%Array(imud+1)
            endif
            
                
            MudSystem%DirectionCoef= (MudSystem%Xend_PipeSection(MudSystem%St_Mud_Forehead_section%Array(imud))-MudSystem%Xstart_PipeSection(MudSystem%St_Mud_Forehead_section%Array(imud))) &
                / ABS(MudSystem%Xend_PipeSection(MudSystem%St_Mud_Forehead_section%Array(imud))-MudSystem%Xstart_PipeSection(MudSystem%St_Mud_Forehead_section%Array(imud)))
            ! +1 for string  ,   -1 for annulus
                
                                                                                                                    
            MudSystem%St_EmptyVolume_inBackheadLocation%Array(imud)= MudSystem%DirectionCoef* (MudSystem%St_Mud_Forehead_X%Array(imud)- MudSystem%Xstart_PipeSection(MudSystem%St_Mud_Forehead_section%Array(imud)))* &
                MudSystem%Area_PipeSectionFt(MudSystem%St_Mud_Backhead_section%Array(imud)) !(ft^3)          
            MudSystem%St_EmptyVolume_inBackheadLocation%Array(imud)= MudSystem%St_EmptyVolume_inBackheadLocation%Array(imud)* 7.48051948d0        ! ft^3  to gal
            

            if ( MudSystem%St_MudDischarged_Volume%Array(imud) <= MudSystem%St_EmptyVolume_inBackheadLocation%Array(imud)) then
                MudSystem%St_Mud_Backhead_section%Array(imud)= MudSystem%St_Mud_Forehead_section%Array(imud)
                MudSystem%St_Mud_Backhead_X%Array(imud)= MudSystem%St_Mud_Forehead_X%Array(imud)- MudSystem%DirectionCoef*(MudSystem%St_MudDischarged_Volume%Array(imud)/7.48051948d0)/MudSystem%Area_PipeSectionFt(MudSystem%St_Mud_Forehead_section%Array(imud))
                                                                            !   7.48051948 is for gal to ft^3
            else
                    
                MudSystem%isection= MudSystem%St_Mud_Backhead_section%Array(imud)-1
                MudSystem%St_RemainedVolume_in_LastSection%Array(imud)= MudSystem%St_MudDischarged_Volume%Array(imud)- MudSystem%St_EmptyVolume_inBackheadLocation%Array(imud)
                    
                do 
                        if (MudSystem%isection < 1) then        ! last pipe section(string exit)
                            MudSystem%St_MudDischarged_Volume%Array(imud)= MudSystem%St_MudDischarged_Volume%Array(imud)- MudSystem%St_RemainedVolume_in_LastSection%Array(imud)
                            MudSystem%St_Mud_Backhead_X%Array(imud)= MudSystem%Xstart_PipeSection(2)
                            MudSystem%St_Mud_Backhead_section%Array(imud)= 2
                            
                            if (MudSystem%St_MudDischarged_Volume%Array(imud)<= 0.0d0)  then        ! imud is completely exited form the string
                                call RemoveStringMudArrays(imud)
                            endif
                            
                            exit
                        endif
                                 
                    MudSystem%xx= MudSystem%St_RemainedVolume_in_LastSection%Array(imud)/ MudSystem%PipeSection_VolumeCapacity(MudSystem%isection)   !(gal)
                        
                    if (MudSystem%xx<= 1.0) then
                        MudSystem%St_Mud_Backhead_section%Array(imud)= MudSystem%isection
                        MudSystem%St_Mud_Backhead_X%Array(imud)= (MudSystem%xx * (MudSystem%Xstart_PipeSection(MudSystem%isection)- MudSystem%Xend_PipeSection(MudSystem%isection)))+ MudSystem%Xend_PipeSection(MudSystem%isection)
                        exit
                    else
                        MudSystem%St_RemainedVolume_in_LastSection%Array(imud)= MudSystem%St_RemainedVolume_in_LastSection%Array(imud)- MudSystem%PipeSection_VolumeCapacity(MudSystem%isection)
                        MudSystem%isection= MudSystem%isection- 1
                                
                    endif

                enddo
            
            endif   
        
    enddo
!========================STRING END================= 
    

    
        
end subroutine Utube2_and_TripIn