subroutine Pumps_StartUp
    Use CPumpsVariables
    Use Pumps_VARIABLES
	IMPLICIT NONE
    !>>>>>>>>>>>>>>>>>>>>>>>  PUMP 1  <<<<<<<<<<<<<<<<<<<<<<<<<<<
    PUMP(1)%FlowRatePerSTK  = .04d0                              ![bbl]  !??????? motaghayere voroudi
    !PUMP(1)%FlowRatePerSTK = PUMP(1)%FlowRatePerSTK*0.0292d0      ![gpm]
    PUMP(1)%RateChange      = 4.d0                                 ![stk/min2  ??]   !??????? motaghayere voroudi
    PUMP(1)%Mech_Efficiency = PumpsSpecification%MudPump1MechanicalEfficiency         ![dimensionless]
    !PUMP(1)%Vol_Efficiency = MudPump1VolumetricEfficiency         !bayad hazf beshe ?
    PUMP(1)%Max_Pressure    = 6000.d0                               ![psi]  !??????? motaghayere voroudi
    PUMP(1)%MaxSPM          = PumpsSpecification%MudPump1Maximum                      ![spm]
    PUMP(1)%Trans_Ratio     = 965.d0/PUMP(1)%MaxSPM
    PUMP(1)%time_step       = 0.1d0                                !?????? niaz hast ya na??
    
    PUMP(1)%RateChange = 193.d0!PUMP(1)%RateChange*PUMP(1)%Trans_Ratio    ! [rpm/min  ??]  ??????????????? rpm/s
    PUMP(1)%K_throttle = 0
    PUMP(1)%N_old      = 0.d0
    Call Pump_OffMode_Solver(1)  
    !>>>>>>>>>>>>>>>>>>>>>>>  PUMP 2  <<<<<<<<<<<<<<<<<<<<<<<<<<<
    PUMP(2)%FlowRatePerSTK  = .04d0                              ![bbl]  !??????? motaghayere voroudi
    !PUMP(2)%FlowRatePerSTK = PUMP(2)%FlowRatePerSTK*0.0292d0      ![gpm]
    PUMP(2)%RateChange      = 4.d0                                 ![stk/min2  ??]   !??????? motaghayere voroudi
    PUMP(2)%Mech_Efficiency = PumpsSpecification%MudPump2MechanicalEfficiency         ![dimensionless]
    !PUMP(2)%Vol_Efficiency = MudPump2VolumetricEfficiency         !bayad hazf beshe ?
    PUMP(2)%Max_Pressure    = 6000.d0                               ![psi]  !??????? motaghayere voroudi
    PUMP(2)%MaxSPM          = PumpsSpecification%MudPump2Maximum                      ![spm]
    PUMP(2)%Trans_Ratio     = 965.d0/PUMP(2)%MaxSPM
    PUMP(2)%time_step       = 0.1d0                                !?????? niaz hast ya na??
    PUMP(2)%RateChange = 193.d0!PUMP(2)%RateChange*PUMP(2)%Trans_Ratio    ! [rpm/min  ??]  ??????????????? rpm/s
    PUMP(2)%K_throttle = 0
    PUMP(2)%N_old      = 0.d0
    Call Pump_OffMode_Solver(2)
    !!>>>>>>>>>>>>>>>>>>>>>>>  PUMP 3  <<<<<<<<<<<<<<<<<<<<<<<<<<<
    PUMP(3)%FlowRatePerSTK  = .04d0                              ![bbl]  !??????? motaghayere voroudi
    !PUMP(3)%FlowRatePerSTK = PUMP(3)%FlowRatePerSTK*0.0292d0      ![gpm]
    PUMP(3)%RateChange      = 4.d0                                 ![stk/min2  ??]   !??????? motaghayere voroudi
    PUMP(3)%Mech_Efficiency = PumpsSpecification%CementPumpMechanicalEfficiency       ![dimensionless]
    !PUMP(3)%Vol_Efficiency = CementPumpVolumetricEfficiency       !bayad hazf beshe ?
    PUMP(3)%Max_Pressure    = 6000.d0                               ![psi]  !??????? motaghayere voroudi
    PUMP(3)%MaxSPM          = PumpsSpecification%CementPumpMaximum                    ![spm]
    PUMP(3)%Trans_Ratio     = 965.d0/PUMP(3)%MaxSPM
    PUMP(3)%time_step       = 0.1d0                                !?????? niaz hast ya na??
    PUMP(3)%RateChange = 193.d0!PUMP(3)%RateChange*PUMP(3)%Trans_Ratio    ! [rpm/min  ??]  ??????????????? rpm/s
    PUMP(3)%K_throttle = 0
    PUMP(3)%N_old      = 0.d0
    Call Pump_OffMode_Solver(3)  
end subroutine Pumps_StartUp