subroutine JetImpactForce

    use sROP_Other_Variables
    use sROP_Variables
    use CStringConfigurationVariables
    use CformationVariables
    ! use CSimulationVariables
    use CmudPropertiesVariables
    use MudSystemVARIABLES
    
    implicit none
    
    Real(8) :: DeltaPb , NozzleTotalArea , Cd=0.95d0
    
    
    
    
    ROP_Bit%BitFlowrate    = MudSystem%StringFlowRateFinal      ![gpm]
    !print*, 'ROP_Bit%BitFlowrate=' , ROP_Bit%BitFlowrate
    !check :: ROP_Bit%MudDensity [ppg]   ??????????
    
    NozzleTotalArea = ROP_Spec%NumberOfBitNozzles*(ROP_Spec%DiameterOfBitNozzle**2)*(PI/4.d0)
    
    DeltaPb         = (8.311d-5*ROP_Bit%MudDensity*(ROP_Bit%BitFlowrate**2))/((Cd**2)*(NozzleTotalArea**2))
    
    ROP_Bit%JetImpactForce = 0.01823d0*Cd*ROP_Bit%BitFlowrate*sqrt(ROP_Bit%MudDensity*DeltaPb)
    
    
    
    
end subroutine