subroutine Drawworks_StartUp

    Use CDrillingConsoleVariables
    Use CHoistingVariables
    Use Drawworks_VARIABLES
    !Use CWarningsVariables
    
	IMPLICIT NONE
    
    
    
    Drawworks%RateChange = 193.d0                       ! [rpm/s?]   !??????? motaghayere voroudi
    
    
    
    !===> Hook Height
    Drawworks%Hook_Height_ini              = 75.0d0                             ![ft]
    Drawworks%Hook_Height_ini_graph_output = -1.54090d0                         ![ft]
    Drawworks%Hook_Height_inim             = 0.3048d0*Drawworks%Hook_Height_ini ![m]
    Drawworks%Hook_Height                  = Drawworks%Hook_Height_inim         ![m]
    Drawworks%Hook_Height_final            = 75.d0                              ![ft]
    Drawworks%TDHookHeight                 = 75.d0                              ![ft]
    
    
    
    !===> Drum (Drawworks) Diameter
    Drawworks%Diameter = 2.50d0                         ![ft]
    Drawworks%Diameter = 0.3048d0*Drawworks%Diameter    ![m]
    
    
    
    !===> Number of Line
    Drawworks%NumberOfLine = Hoisting%NumberOfLine
    
    
    
    !===> Simulation time step
    Drawworks%time_step = 0.10d0                        ![s]
    
    
    
    !===> Initial Values
    Drawworks%w_drum               = 0.d0
    Drawworks%w_old_drum           = 0.d0
    Drawworks%motion               = 0
    Drawworks%K_Throttle           = 0
    Drawworks%StringIsBottomOfWell = 0                  ! 1= string is at the bottom of the well
    !Drawworks%CrownCollision      = 0
    !Drawworks%FloorCollision      = 0
    
    
    
    
end subroutine Drawworks_StartUp