subroutine RTable_StartUp

    Use RTable_VARIABLES
    
	IMPLICIT NONE
    
    
        
    RTable%Inertia_Moment  = 23.261341d0       ! 23.261341[kg.m^2] = 552[lb.ft^2]
    RTable%Mech_Efficiency = 0.93d0
    RTable%RateChange      = 1.d0              ![Hz/s]     !??????? motaghayere voroudi
    RTable%High_Conv_Ratio = 4.825d0
    RTable%Low_Conv_Ratio  = 7.31d0
    RTable%time_step       = 0.1d0             ![s]
    RTable%MaxRPM          = 200.d0            ![RPM]      !??????? motaghayere voroudi
    RTable%MaxTorque       = 1500.d0           ![ft.lbf]   !??????? motaghayere voroudi
    
    
    
    RTable%RateChange    = RTable%RateChange*60.d0   ![RPM/s]         ![cycle/min]=[RPM]     !1[Hz]=60[RPM]
    RTable%J_coef        = RTable%Inertia_Moment+(1.d0*(RTable%Inertia_Moment)) 
    RTable%Conv_Ratio    = RTable%Low_Conv_Ratio
    RTable%String_JCoef  = 0.d0  
    RTable%Torque        = 0.d0
    RTable%K_throttle    = 0
    RTable%Speed         = 0.d0
    RTable%TorqueGaugeOutput = 0.d0
    call RTable_OffMode
    
    
    
end subroutine RTable_StartUp