subroutine TD_ForceReadData
    
   Use CHoistingVariables
   Use TD_DrillStemComponents
   Use TD_WellElements
   Use TD_WellGeometry
   Use TD_GeneralData
   Use TD_StringConnectionData
   Use RTable_VARIABLES, only: RTable
   Use sROP_Variables
   Use TopDrive_VARIABLES, only: TDS
   

   implicit none
   
   
   integer :: i
   
   
   
   TD_String%DrillStemAxialVelocity = TD_StConn%StringVelocity
   Do i = 1 , TD_String%DrillStemComponentsNumbs
       if ( Hoisting%DriveType==1) then
           TD_String%DrillStemRotVelocity = (2.d0*pi*TD_DrillStems(i)%RtoolJoint)*(RTable%Speed)/60.d0                   ! RTable%Speed[RPM] ---> TD_String%DrillStemRotVelocity[ft/s]
       else if ( Hoisting%DriveType==0) then
           TD_String%DrillStemRotVelocity = (2.d0*pi*TD_DrillStems(i)%RtoolJoint)*(TDS%Speed+RTable%Speed)/60.d0         ! TDS%Speed[RPM] ---> TD_String%DrillStemRotVelocity[ft/s]
       end if
   End Do
   
   
   
   
   TD_String%BitTorque = ROP_Bit%BitTorque
   

   
   
   
   !TD_String%DrillStemAxialVelocity = 0.0        !???????????????????
   !TD_String%DrillStemRotVelocity   = 0.0        !???????????????????

   
   
   
    TD_String%DrillStemForceType = 0
    if(TD_String%DrillStemAxialVelocity > 0.) then  !??????????????????? check
        TD_String%DrillStemForceType = 1
        if(TD_String%DrillStemRotVelocity /= 0.d0)   TD_String%DrillStemForceType = 2
    else if(TD_String%DrillStemAxialVelocity < 0.d0) then
        TD_String%DrillStemForceType = 3
        if(TD_String%DrillStemRotVelocity /= 0.d0) TD_String%DrillStemForceType = 4
    else if(TD_String%DrillStemAxialVelocity == 0.d0) then
        TD_String%DrillStemForceType = 5    !no axial motion
    end if

    
    
    
    
   
end subroutine